=== modified file 'pom.xml'
--- pom.xml	2017-08-17 11:10:50 +0000
+++ pom.xml	2017-08-28 13:28:34 +0000
@@ -58,6 +58,28 @@
       <version>42.1.4</version>
     </dependency>
 
+    <!-- https://mvnrepository.com/artifact/junit/junit -->
+    <dependency>
+      <groupId>junit</groupId>
+      <artifactId>junit</artifactId>
+      <version>4.12</version>
+    </dependency>
+    <!-- https://mvnrepository.com/artifact/javax.faces/javax.faces-api -->
+    <dependency>
+      <groupId>javax.faces</groupId>
+      <artifactId>javax.faces-api</artifactId>
+      <version>2.3</version>
+      <scope>provided</scope>
+    </dependency>
+    <!-- https://mvnrepository.com/artifact/org.bouncycastle/bcprov-jdk15on -->
+    <dependency>
+      <groupId>org.bouncycastle</groupId>
+      <artifactId>bcprov-jdk15on</artifactId>
+      <version>1.58</version>
+    </dependency>
+
   </dependencies>
 
+
+
 </project>

=== added file 'src/main/java/beans/ConfigBean.java'
--- src/main/java/beans/ConfigBean.java	1970-01-01 00:00:00 +0000
+++ src/main/java/beans/ConfigBean.java	2017-08-29 08:24:15 +0000
@@ -0,0 +1,49 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
+import java.io.Serializable;
+
+import javax.faces.bean.*;
+
+
+@SuppressWarnings({"serial", "deprecation"})
+@ManagedBean(name = "configBean", eager = true)
+@ApplicationScoped
+public class
+ConfigBean implements Serializable {
+  /****************************************************************************/
+  private static String
+    PAGE_TITLE = "MAG Student Portal";
+
+  private static String
+    PAGE_SUB_TITLE = "My school";
+
+  private static String
+    PAGE_HEADER_TITLE_URL = "./index.xhtml";
+
+  private static String
+    PAGE_HEADER_SUB_TITLE_URL = "./index.xhtml";
+
+  /****************************************************************************/
+  public String
+  getPageTitle () {
+    return PAGE_TITLE;
+  }
+
+  public String
+  getSubTitle () {
+    return PAGE_SUB_TITLE;
+  }
+
+  public String
+  getHeaderTitleUrl () {
+    return PAGE_HEADER_TITLE_URL;
+  }
+
+  public String
+  getHeaderSubTitleUrl () {
+    return PAGE_HEADER_SUB_TITLE_URL;
+  }
+}

=== modified file 'src/main/java/beans/LoginBean.java'
--- src/main/java/beans/LoginBean.java	2017-08-18 12:05:06 +0000
+++ src/main/java/beans/LoginBean.java	2017-08-29 08:24:15 +0000
@@ -1,9 +1,35 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package beans;
 
-import javax.faces.bean.SessionScoped;
-
+import javax.faces.bean.*;
+
+import common.*;
+
+
+@ManagedBean
 @SessionScoped
 public class
 LoginBean {
-  
+  private boolean
+    is_logged_in = false;
+
+  private UserTypeEnum
+    user_type = UserTypeEnum.NONE;
+
+
+  /****************************************************************************/
+
+  public void
+  studentLogin (String user_name, String password) {
+
+  }
+
+  public void
+  staffLogin (String user_name, String password) {
+
+  }
 }

=== modified file 'src/main/java/common/Config.java'
--- src/main/java/common/Config.java	2017-08-18 12:05:06 +0000
+++ src/main/java/common/Config.java	2017-08-29 08:24:15 +0000
@@ -1,3 +1,8 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package common;
 
 public class Config {

=== added file 'src/main/java/common/UserTypeEnum.java'
--- src/main/java/common/UserTypeEnum.java	1970-01-01 00:00:00 +0000
+++ src/main/java/common/UserTypeEnum.java	2017-08-29 08:26:42 +0000
@@ -0,0 +1,23 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
+package common;
+
+public enum UserTypeEnum {
+  NONE(0),
+  STUDENT(1),
+  STAFF(2);
+
+  int value;
+
+  UserTypeEnum (int i) {
+    this.value = i;
+  }
+
+  public int
+  getValue () {
+    return value;
+  }
+}

=== modified file 'src/main/java/common/Utils.java'
--- src/main/java/common/Utils.java	2017-08-18 12:24:30 +0000
+++ src/main/java/common/Utils.java	2017-08-29 08:24:15 +0000
@@ -1,5 +1,14 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package common;
 
+import org.bouncycastle.jcajce.provider.digest.SHA3.*;
+import org.bouncycastle.util.encoders.*;
+
+
 public class
 Utils {
   private Utils () {};
@@ -15,15 +24,15 @@
   static public String
   real_hash_func (String t, String s) {
     int a = t.getBytes()[0];
-    @SuppressWarnings("unused")
     int b = t.getBytes()[a%t.length()];
     
-    /* Rotate the string as here:
-     *  
-     */
-    
-    
-    return null;
+    StringBuilder sb = new StringBuilder ();
+    sb.append (t).insert (b, s);
+    
+    DigestSHA3 md = DigestSHA3 (2048);
+    md.update (sb.toString().getBytes("UTF-8"));
+
+    return Hex.toHexString (md.digits ());
   }
   
   /**

=== modified file 'src/main/java/db/Course.java'
--- src/main/java/db/Course.java	2017-08-17 13:09:18 +0000
+++ src/main/java/db/Course.java	2017-08-29 08:24:15 +0000
@@ -1,3 +1,8 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package DB;
 
 import java.io.Serializable;

=== modified file 'src/main/java/db/Lecture.java'
--- src/main/java/db/Lecture.java	2017-08-18 12:02:27 +0000
+++ src/main/java/db/Lecture.java	2017-08-29 08:24:15 +0000
@@ -1,3 +1,8 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package DB;
 
 import java.io.Serializable;

=== modified file 'src/main/java/db/LecturePK.java'
--- src/main/java/db/LecturePK.java	2017-08-18 12:02:27 +0000
+++ src/main/java/db/LecturePK.java	2017-08-29 08:24:15 +0000
@@ -1,3 +1,8 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package DB;
 
 import java.io.Serializable;

=== modified file 'src/main/java/db/Staff.java'
--- src/main/java/db/Staff.java	2017-08-18 12:02:27 +0000
+++ src/main/java/db/Staff.java	2017-08-29 08:24:15 +0000
@@ -1,3 +1,8 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package DB;
 
 import java.io.Serializable;

=== modified file 'src/main/java/db/StaffType.java'
--- src/main/java/db/StaffType.java	2017-08-18 12:02:27 +0000
+++ src/main/java/db/StaffType.java	2017-08-29 08:24:15 +0000
@@ -1,3 +1,8 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package DB;
 
 import java.io.Serializable;

=== modified file 'src/main/java/db/Student.java'
--- src/main/java/db/Student.java	2017-08-18 12:02:27 +0000
+++ src/main/java/db/Student.java	2017-08-29 08:24:15 +0000
@@ -1,3 +1,8 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package DB;
 
 import java.io.Serializable;

=== modified file 'src/main/java/db/StudentAttendance.java'
--- src/main/java/db/StudentAttendance.java	2017-08-18 12:02:27 +0000
+++ src/main/java/db/StudentAttendance.java	2017-08-29 08:24:15 +0000
@@ -1,3 +1,8 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package DB;
 
 import java.io.Serializable;

=== modified file 'src/main/java/db/StudentAttendancePK.java'
--- src/main/java/db/StudentAttendancePK.java	2017-08-18 12:02:27 +0000
+++ src/main/java/db/StudentAttendancePK.java	2017-08-29 08:24:15 +0000
@@ -1,3 +1,8 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package DB;
 
 import java.io.Serializable;

=== modified file 'src/main/java/db/Teach.java'
--- src/main/java/db/Teach.java	2017-08-18 12:02:27 +0000
+++ src/main/java/db/Teach.java	2017-08-29 08:24:15 +0000
@@ -1,3 +1,8 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package DB;
 
 import java.io.Serializable;

=== modified file 'src/main/java/db/TeachPK.java'
--- src/main/java/db/TeachPK.java	2017-08-18 12:02:27 +0000
+++ src/main/java/db/TeachPK.java	2017-08-29 08:24:15 +0000
@@ -1,3 +1,8 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
 package DB;
 
 import java.io.Serializable;

=== modified file 'src/main/webapp/StudentLogin.xhtml'
--- src/main/webapp/StudentLogin.xhtml	2017-08-11 12:15:56 +0000
+++ src/main/webapp/StudentLogin.xhtml	2017-08-29 08:24:15 +0000
@@ -1,13 +1,17 @@
 <?xml version="1.0" encoding="UTF-8"?>
+<!-- c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+  vi: set shiftwidth=2 tabstop=2 expandtab:
+  :indentSize=2:tabSize=2:noTabs=true:
+-->
 <!DOCTYPE html>
 <html xmlns="http://www.w3.org/1999/xhtml"
       xmlns:h="http://xmlns.jcp.org/jsf/html"
       xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
       xmlns:f="http://xmlns.jcp.org/jsf/core">
 <f:view>
-        <ui:composition template="WEB-INF/templates/login.xhtml">
-            <ui:param name="username" value="StudentLoginBean.username"/>
-            <ui:param name="password" value="StudentLoginBean.password"/>
-        </ui:composition>
+    <ui:composition template="WEB-INF/templates/login.xhtml">
+        <ui:param name="username" value="StudentLoginBean.username"/>
+        <ui:param name="password" value="StudentLoginBean.password"/>
+    </ui:composition>
 </f:view>
 </html>

=== modified file 'src/main/webapp/WEB-INF/templates/corse_card.xhtml'
--- src/main/webapp/WEB-INF/templates/corse_card.xhtml	2017-08-11 12:15:56 +0000
+++ src/main/webapp/WEB-INF/templates/corse_card.xhtml	2017-08-29 08:24:15 +0000
@@ -1,4 +1,8 @@
 <?xml version="1.0" encoding="UTF-8"?>
+<!-- c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+  vi: set shiftwidth=2 tabstop=2 expandtab:
+  :indentSize=2:tabSize=2:noTabs=true:
+-->
 <!DOCTYPE html>
 <html xmlns="http://www.w3.org/1999/xhtml"
       xmlns:h="http://xmlns.jcp.org/jsf/html"

=== modified file 'src/main/webapp/WEB-INF/templates/login.xhtml'
--- src/main/webapp/WEB-INF/templates/login.xhtml	2017-08-11 12:15:56 +0000
+++ src/main/webapp/WEB-INF/templates/login.xhtml	2017-08-29 08:24:15 +0000
@@ -1,4 +1,8 @@
 <?xml version="1.0" encoding="UTF-8"?>
+<!-- c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+  vi: set shiftwidth=2 tabstop=2 expandtab:
+  :indentSize=2:tabSize=2:noTabs=true:
+-->
 <!DOCTYPE html>
 <html xmlns="http://www.w3.org/1999/xhtml"
       xmlns:h="http://xmlns.jcp.org/jsf/html"

=== modified file 'src/main/webapp/WEB-INF/templates/page_header.xhtml'
--- src/main/webapp/WEB-INF/templates/page_header.xhtml	2017-08-11 12:15:56 +0000
+++ src/main/webapp/WEB-INF/templates/page_header.xhtml	2017-08-29 08:24:15 +0000
@@ -1,14 +1,22 @@
-<?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE html>
-<html xmlns="http://www.w3.org/1999/xhtml"
-      xmlns:h="http://xmlns.jcp.org/jsf/html"
-      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
-      xmlns:f="http://xmlns.jcp.org/jsf/core"
-      xmlns:pt="http://xmlns.jcp.org/jsf/passthrough">
+<!-- c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+  vi: set shiftwidth=2 tabstop=2 expandtab:
+  :indentSize=2:tabSize=2:noTabs=true:
+-->
+<html lang="en" xmlns:h="http://xmlns.jcp.org/jsf/html"
+  xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
+  xmlns:f="http://xmlns.jcp.org/jsf/core"
+  xmlns:pt="http://xmlns.jcp.org/jsf/passthrough">
 <ui:composition>
-    <div class="header_bar">
-        <h1>${pageTitle}</h1>
-        
-    </div>
+  <div class="header_bar">
+    <header>
+      <a href="#{configBean.headerTitleUrl}">
+        <h1>#{configBean.pageTitle}</h1>
+      </a>
+      <a href="#{configBean.headerSubTitleUrl}">
+        <p>#{configBean.subTitle}</p>
+      </a>
+    </header>
+  </div>
 </ui:composition>
 </html>

=== modified file 'src/main/webapp/WEB-INF/web.xml'
--- src/main/webapp/WEB-INF/web.xml	2017-08-02 14:06:36 +0000
+++ src/main/webapp/WEB-INF/web.xml	2017-08-29 08:24:15 +0000
@@ -1,10 +1,13 @@
 <?xml version="1.0"?>
-
+<!-- c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+  vi: set shiftwidth=2 tabstop=2 expandtab:
+  :indentSize=2:tabSize=2:noTabs=true:
+-->
 <web-app xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
-         xmlns="http://java.sun.com/xml/ns/javaee"
-         xsi:schemaLocation="http://java.sun.com/xml/ns/javaee
+  xmlns="http://java.sun.com/xml/ns/javaee"
+  xsi:schemaLocation="http://java.sun.com/xml/ns/javaee
       http://java.sun.com/xml/ns/javaee/web-app_2_5.xsd"
-         version="2.5">
+  version="2.5">
 
   <description>MyProject web.xml</description>
 
@@ -25,5 +28,4 @@
   <welcome-file-list>
     <welcome-file>index.xhtml</welcome-file>
   </welcome-file-list>
-
 </web-app>
\ No newline at end of file

=== modified file 'src/main/webapp/index.xhtml'
--- src/main/webapp/index.xhtml	2017-08-03 13:44:11 +0000
+++ src/main/webapp/index.xhtml	2017-08-29 08:24:15 +0000
@@ -1,10 +1,23 @@
-<?xml version="1.0" encoding="UTF-8"?>
+<?xml version="1.0" encoding="UTF-8" ?>
+<!-- c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+  vi: set shiftwidth=2 tabstop=2 expandtab:
+  :indentSize=2:tabSize=2:noTabs=true:
+-->
 <!DOCTYPE html>
 <html xmlns="http://www.w3.org/1999/xhtml"
-      xmlns:h="http://xmlns.jcp.org/jsf/html"
-      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
-      xmlns:f="http://xmlns.jcp.org/jsf/core">
-<f:view>
-     <h:outputLabel value="Hello, world"/>
-</f:view>
+  xmlns:ui="http://java.sun.com/jsf/facelets"
+  xmlns:f="http://xmlns.jcp.org/jsf/core"
+  xmlns:h="http://xmlns.jcp.org/jsf/html"
+  xmlns:pt="http://xmlns.jcp.org/jsf/passthrough">
+<h:head>
+  <h:outputStylesheet library="css" name="main.css" />
+  <title>${configBean.pageTitle} - ${configBean.subTitle}</title>
+</h:head>
+<h:body>
+  <ui:decorate template="WEB-INF/templates/page_header.xhtml" />
+
+  <div class="main-view">
+    <!--  Stuffs goes here. -->
+  </div>
+</h:body>
 </html>

=== added directory 'src/main/webapp/resources'
=== added directory 'src/main/webapp/resources/css'
=== added file 'src/main/webapp/resources/css/main.css'
--- src/main/webapp/resources/css/main.css	1970-01-01 00:00:00 +0000
+++ src/main/webapp/resources/css/main.css	2017-08-28 13:28:34 +0000
@@ -0,0 +1,53 @@
+body {
+  padding: 0px;
+  margin: 0px;
+}
+
+a:visited {
+  color: darkblue;
+}
+
+a:hover {
+  color: darkblue;
+}
+
+a {
+  color: darkblue;
+}
+
+.header_bar {
+  background-color: lightgray;
+  margin-left: 0px;
+  margin-top: -4.5em;
+  box-shadow: 0px 5px 5px black;
+  margin-right: 0px;
+  z-index: 666 !important;
+  position: fixed;
+  width: 100%;
+}
+
+.header_bar header {
+  margin: 0px;
+  padding: 9px;
+  padding-top: 0px;
+}
+
+.header_bar header h1 {
+  padding: 0px;
+  margin: 0px;
+}
+.header_bar header p {
+  padding: 0px;
+  margin: 0px;
+}
+
+
+.main-view {
+  width: 70em;
+  min-height: 10em;
+  margin-left: auto;
+  margin-right: auto;
+  margin-top:4.50em;
+  background-color: lightgray;
+  box-shadow: 0px 0px 5px black;
+}

=== added directory 'src/test'
=== added directory 'src/test/java'
=== added file 'src/test/java/AllTests.java'
--- src/test/java/AllTests.java	1970-01-01 00:00:00 +0000
+++ src/test/java/AllTests.java	2017-08-29 08:24:15 +0000
@@ -0,0 +1,14 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
+import org.junit.runner.RunWith;
+import org.junit.runners.Suite;
+import org.junit.runners.Suite.SuiteClasses;
+
+@RunWith(Suite.class)
+@SuiteClasses({ TestHash.class })
+public class AllTests {
+
+}

=== added file 'src/test/java/TestHash.java'
--- src/test/java/TestHash.java	1970-01-01 00:00:00 +0000
+++ src/test/java/TestHash.java	2017-08-29 08:24:15 +0000
@@ -0,0 +1,16 @@
+/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
+ * vi: set shiftwidth=2 tabstop=2 expandtab:
+ * :indentSize=2:tabSize=2:noTabs=true:
+ */
+
+import org.junit.*;
+
+import common.Utils;
+
+public class TestHash {
+  @Test
+  public void test1 () {
+    System.out.println(Utils.hash_func("Hello World"));
+  }
+
+}

